VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "CompareDBTables"
   ClientHeight    =   4770
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7800
   LinkTopic       =   "Form1"
   ScaleHeight     =   4770
   ScaleWidth      =   7800
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCompare 
      Caption         =   "Compare"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   3120
      TabIndex        =   7
      Top             =   4320
      Width           =   855
   End
   Begin VB.ListBox lstTables 
      Height          =   2700
      IntegralHeight  =   0   'False
      Left            =   0
      TabIndex        =   6
      Top             =   1440
      Width           =   7455
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   5520
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtDb 
      Height          =   285
      Index           =   1
      Left            =   0
      TabIndex        =   5
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton cmdBrowse 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Index           =   1
      Left            =   4680
      Picture         =   "Form1.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   600
      Width           =   375
   End
   Begin VB.CommandButton cmdBrowse 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Index           =   0
      Left            =   4680
      Picture         =   "Form1.frx":0182
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   240
      Width           =   375
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   960
      Width           =   855
   End
   Begin VB.TextBox txtDb 
      Height          =   285
      Index           =   0
      Left            =   0
      TabIndex        =   1
      Top             =   240
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "Databases"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const APP_NAME As String = "CompareDBTables"
Private Function CompareTables(db() As DAO.Database, table_def() As DAO.TableDef) As String
Dim results As String
Dim i As Integer
Dim field_mismatch As Boolean
Dim col_wid() As Integer
Dim data_wid As Integer
Dim compare_value As Integer
Dim rs(0 To 1) As DAO.Recordset
Dim Value(0 To 1) As String
Dim query As String

    ' Verify that the tables have the same number of columns.
    If table_def(0).Fields.Count <> table_def(1).Fields.Count Then
        CompareTables = "Tables have different numbers of fields"
        Exit Function
    End If

    ' Verify that the tables have the same colunm names and types.
    For i = 0 To table_def(0).Fields.Count - 1
        If table_def(0).Fields(i).Name <> table_def(1).Fields(i).Name Then
            field_mismatch = True
        ElseIf table_def(0).Fields(i).Type <> table_def(1).Fields(i).Type Then
            field_mismatch = True
        Else
            field_mismatch = False
        End If

        If field_mismatch Then
            results = results & "  Field " & i & ": " & _
                table_def(0).Fields(i).Name & _
                " (" & table_def(0).Fields(i).Type & ") <> " & _
                table_def(1).Fields(i).Name & _
                " (" & table_def(1).Fields(i).Type & ")" & vbCrLf
        End If
    Next i
    If Len(results) > 0 Then
        CompareTables = results
        Exit Function
    End If

    ' Get the column widths.
    ReDim col_wid(0 To table_def(0).Fields.Count - 1)
    For i = 0 To table_def(0).Fields.Count - 1
        col_wid(i) = Len(table_def(0).Fields(i).Name)
        data_wid = DataWidth(table_def(0).Fields(i))
        If col_wid(i) < data_wid Then col_wid(i) = data_wid
    Next i

    ' Make a record header.
    results = results & RecordHeader(col_wid, table_def(0)) & vbCrLf

    ' Select the records, ordered by all fields.
    query = "SELECT * FROM " & _
        table_def(0).Name & " ORDER BY "
    For i = 0 To table_def(0).Fields.Count - 1
        If table_def(0).Fields(i).Type <> dbMemo Then
            query = query & table_def(0).Fields(i).Name & ", "
        End If
    Next i
    query = Left$(query, Len(query) - 2)

    Set rs(0) = db(0).OpenRecordset(query, dbOpenSnapshot)
    Set rs(1) = db(1).OpenRecordset(query, dbOpenSnapshot)

    ' Compare records.
    Do Until (rs(0).EOF Or rs(1).EOF)
        ' See which record comes before the other.
        compare_value = 0
        For i = 0 To table_def(0).Fields.Count - 1
            If table_def(0).Fields(i).Type <> dbMemo Then
                Value(0) = "" & rs(0).Fields(i)
                Value(1) = "" & rs(1).Fields(i)
                If Value(0) < Value(1) Then
                    compare_value = -1
                    Exit For
                ElseIf Value(0) > Value(1) Then
                    compare_value = 1
                    Exit For
                End If
            End If
        Next i

        ' See if the records match.
        If compare_value < 0 Then
            results = results & "< " & RecordString(col_wid, rs(0)) & vbCrLf
            rs(0).MoveNext
        ElseIf compare_value > 0 Then
            results = results & "> " & RecordString(col_wid, rs(1)) & vbCrLf
            rs(1).MoveNext
        Else
            ' They match. Skip this record.
            rs(0).MoveNext
            rs(1).MoveNext
        End If
    Loop

    ' Display remaining rs(0) records.
    Do Until (rs(0).EOF)
        results = results & "< " & RecordString(col_wid, rs(0)) & vbCrLf
        rs(0).MoveNext
    Loop

    ' Display remaining rs(1) records.
    Do Until (rs(1).EOF)
        results = results & "> " & RecordString(col_wid, rs(1)) & vbCrLf
        rs(1).MoveNext
    Loop

    CompareTables = results & vbCrLf
End Function
Private Function DataWidth(ByVal field_def As Field)
    Select Case field_def.Type
        Case dbByte
            DataWidth = 3
        Case dbInteger
            DataWidth = 6
        Case dbLong, 14     ' Auto Number
            DataWidth = 11
        Case dbSingle
            DataWidth = 9
        Case dbDouble
            DataWidth = 17
        Case dbDecimal
            DataWidth = 17
        Case dbText
            DataWidth = field_def.Size
        Case dbMemo
            DataWidth = 4
        Case dbDate
            DataWidth = 19
        Case dbCurrency
            DataWidth = 7
        Case dbBoolean
            DataWidth = 3
        Case Else
            DataWidth = 3
    End Select
End Function
Private Function DataTypeName(ByVal data_type As Integer)
    Select Case data_type
        Case dbByte
            DataTypeName = "Byte"
        Case dbInteger
            DataTypeName = "Integer"
        Case dbLong
            DataTypeName = "Long Integer"
        Case dbSingle
            DataTypeName = "Single"
        Case dbDouble
            DataTypeName = "Double"
        Case dbDecimal
            DataTypeName = "Decimal"
        Case dbText
            DataTypeName = "Text"
        Case dbMemo
            DataTypeName = "Memo"
        Case dbDate
            DataTypeName = "Date"
        Case dbCurrency
            DataTypeName = "Currency"
        Case dbBoolean
            DataTypeName = "Boolean"
        Case 14
            DataTypeName = "Auto Number"
        Case Else
            DataTypeName = "???"
    End Select
End Function

Private Function FieldString(ByVal wid As Integer, ByVal field_def As DAO.Field) As String
Dim mask As String

    mask = "!" & String$(wid, "@")
    If field_def.Type = dbMemo Then
        FieldString = Format$("Memo", mask)
    Else
        FieldString = Format$(field_def.Value, mask)
    End If
End Function

Private Function RecordString(col_wid() As Integer, ByVal rs As DAO.Recordset) As String
Dim results As String
Dim i As Integer

    For i = 0 To rs.Fields.Count - 1
        results = results & FieldString(col_wid(i) + 1, rs.Fields(i))
    Next i

    RecordString = results
End Function
Private Function RecordHeader(col_wid() As Integer, ByVal table_def As DAO.TableDef) As String
Dim line1 As String
Dim line2 As String
Dim i As Integer
Dim mask As String

    line1 = "  "
    line2 = "  "

    For i = 0 To table_def.Fields.Count - 1
        mask = "!" & String$(col_wid(i) + 1, "@")
        line1 = line1 & Format$(table_def.Fields(i).Name, mask)
        line2 = line2 & String$(col_wid(i), "-") & " "
    Next i

    RecordHeader = line1 & vbCrLf & line2
End Function
Private Sub cmdBrowse_Click(Index As Integer)
    dlgFile.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
    dlgFile.CancelError = True
    dlgFile.Filter = "Access Files (*.mdb)|*.mdb|All Files (*.*)|*.*"
    dlgFile.FilterIndex = 0
    dlgFile.FileName = txtDb(Index).Text

    On Error Resume Next
    dlgFile.ShowOpen

    If Err.Number = cdlCancel Then Exit Sub
    If Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " selecting database." & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    On Error GoTo 0

    txtDb(Index).Text = dlgFile.FileName
End Sub

Private Sub cmdCompare_Click()
Dim i As Integer
Dim db(0 To 1) As DAO.Database
Dim td_num(0 To 1) As Integer
Dim table_def(0 To 1) As DAO.TableDef
Dim results As String

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Open the databases.
    For i = 0 To 1
        ' Open the database.
        On Error GoTo DBOpenError
        Set db(i) = DBEngine.Workspaces(0).OpenDatabase( _
            txtDb(i).Text, ReadOnly:=False)
        On Error GoTo 0
    
        ' Get the selected TableDef.
        Set table_def(i) = db(i).TableDefs(lstTables.Text)
    Next i

    ' Compare the tables.
    results = CompareTables(db, table_def)

    Screen.MousePointer = vbDefault
    dlgResults.txtResults.Text = results
    dlgResults.Show vbModal
    Exit Sub

DBOpenError:
    If db(0) Is Nothing Then
        MsgBox "Error " & Err.Number & _
            " opening database " & _
            txtDb(0).Text & vbCrLf & Err.Description
    Else
        MsgBox "Error " & Err.Number & _
            " opening database " & _
            txtDb(1).Text & vbCrLf & Err.Description
        db(0).Close
    End If
    Screen.MousePointer = vbDefault
    Exit Sub
End Sub

Private Sub cmdLoad_Click()
Dim i As Integer
Dim db(0 To 1) As DAO.Database
Dim td_num(0 To 1) As Integer
Dim table_def(0 To 1) As DAO.TableDef

    lstTables.Clear
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Open the databases.
    For i = 0 To 1
        ' Open the database.
        On Error GoTo DBOpenError
        Set db(i) = DBEngine.Workspaces(0).OpenDatabase( _
            txtDb(i).Text, ReadOnly:=False)
        On Error GoTo 0

        ' Start with the first TableDef.
        td_num(i) = 0
        Set table_def(i) = db(i).TableDefs(0)
    Next i

    ' Compare the tables.
    Do While (td_num(0) < db(0).TableDefs.Count) And (td_num(1) < db(1).TableDefs.Count)
        ' Get the TableDefs.
        Set table_def(0) = db(0).TableDefs(td_num(0))
        Set table_def(1) = db(1).TableDefs(td_num(1))

        ' See if they're the same table.
        If LCase$(Left$(table_def(0).Name, 4)) = "msys" Then
            ' Skip DB 0 system table.
            td_num(0) = td_num(0) + 1
        ElseIf LCase$(Left$(table_def(1).Name, 4)) = "msys" Then
            ' Skip DB 1 system table.
            td_num(1) = td_num(1) + 1
        ElseIf table_def(0).Name < table_def(1).Name Then
            ' DB 1 is missing a table.
            td_num(0) = td_num(0) + 1
        ElseIf table_def(0).Name > table_def(1).Name Then
            ' DB 0 is missing a table.
            td_num(1) = td_num(1) + 1
        Else
            ' Both DBs have this table.
            lstTables.AddItem table_def(0).Name
            td_num(0) = td_num(0) + 1
            td_num(1) = td_num(1) + 1
        End If
    Loop
    db(0).Close
    db(1).Close

    cmdCompare.Enabled = False
    Screen.MousePointer = vbDefault
    Exit Sub

DBOpenError:
    If db(0) Is Nothing Then
        MsgBox "Error " & Err.Number & _
            " opening database " & _
            txtDb(0).Text & vbCrLf & Err.Description
    Else
        MsgBox "Error " & Err.Number & _
            " opening database " & _
            txtDb(1).Text & vbCrLf & Err.Description
        db(0).Close
    End If
    Screen.MousePointer = vbDefault
    Exit Sub
End Sub

Private Sub Form_Load()
Dim i As Integer

    dlgFile.InitDir = App.Path

    For i = 0 To 1
        txtDb(i).Text = GetSetting(APP_NAME, "Settings", "DB" & i, "")
    Next i
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    cmdBrowse(0).Left = ScaleWidth - cmdBrowse(0).Width
    cmdBrowse(1).Left = ScaleWidth - cmdBrowse(1).Width

    wid = ScaleWidth - cmdBrowse(0).Width - 60
    If wid < 120 Then wid = 120
    txtDb(0).Width = wid
    txtDb(1).Width = wid

    cmdLoad.Left = (ScaleWidth - cmdLoad.Width) / 2
    cmdCompare.Left = (ScaleWidth - cmdCompare.Width) / 2
    cmdCompare.Top = ScaleHeight - cmdCompare.Height

    hgt = cmdCompare.Top - lstTables.Top - 30
    If hgt < 120 Then hgt = 120
    lstTables.Move 0, lstTables.Top, ScaleWidth, hgt
End Sub


Private Sub Form_Unload(Cancel As Integer)
Dim i As Integer

    For i = 0 To 1
        SaveSetting APP_NAME, "Settings", "DB" & i, txtDb(i).Text
    Next i
End Sub

Private Sub lstTables_Click()
    cmdCompare.Enabled = (lstTables.ListIndex >= 0)
End Sub

Private Sub txtDb_Change(Index As Integer)
    lstTables.Clear
    cmdCompare.Enabled = False
End Sub


